"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _types = _interopRequireDefault(require("./types"));

var _index = _interopRequireDefault(require("ant-design-vue/es/date-picker/index"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * @Date: 2020/11/23 7:55 下午
 * @Author: Fioanna
 * @Description: 日期选择器
 */
var ARangePicker = _index["default"].RangePicker;
var _default = {
  name: 'EDateRange',
  props: _types["default"],
  data: function data() {
    return {
      dates: []
    };
  },
  computed: {
    rangeDates: function rangeDates() {
      return [this.startValue, this.endValue];
    }
  },
  methods: {
    _change: function _change(dates) {
      // 按照valueFormat的格式输出时间列表
      this.$emit('change', dates);
    }
  },
  render: function render() {
    var h = arguments[0];
    var _this$$props = this.$props,
        disabled = _this$$props.disabled,
        showTime = _this$$props.showTime,
        showFormat = _this$$props.showFormat,
        valueFormat = _this$$props.valueFormat,
        disabledDate = _this$$props.disabledDate; // placeholder={['开始时间', '结束时间']}

    return h(ARangePicker, {
      attrs: {
        disabled: disabled,
        showTime: showTime,
        format: showFormat,
        valueFormat: valueFormat,
        disabledDate: disabledDate,
        value: this.rangeDates
      },
      on: {
        "change": this._change
      }
    });
  }
};
exports["default"] = _default;