"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formProps = exports.formMixinProps = void 0;

var _vueTypes = _interopRequireDefault(require("ant-design-vue/es/_util/vue-types"));

var _extends2 = _interopRequireDefault(require("babel-runtime/helpers/extends"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/* 混入的props */
var formMixinProps = {
  // 表单item列表
  list: _vueTypes["default"].oneOfType([_vueTypes["default"].array, _vueTypes["default"].shape({
    // 表单key
    key: _vueTypes["default"].oneOfType([_vueTypes["default"].string, _vueTypes["default"].number]).required,
    // 表单label
    label: _vueTypes["default"].string.required,
    // 类型
    type: _vueTypes["default"].string.required,
    // 表单关联key
    keys: _vueTypes["default"].array,
    // 组件的props
    props: _vueTypes["default"].object,
    // 是否必输
    required: _vueTypes["default"].bool,
    // 校验规则
    rules: _vueTypes["default"].array,
    // 选择器组件无默认值时是否需要初始化默认选中第一个
    init: _vueTypes["default"].bool,
    // 选择器组件字典类型的传入dictId
    dictId: _vueTypes["default"].bool,
    // 是否需要全部，下拉选择器select有此参数
    needAll: _vueTypes["default"].bool,
    // 未定义type且无对应插槽时有效
    customRenderItem: _vueTypes["default"].func,
    // 针对searchBar，最终getValue的方法
    customRender: _vueTypes["default"].func
  })]),
  // 表单默认数据
  formData: _vueTypes["default"].object
};
/* 表单的props */

exports.formMixinProps = formMixinProps;
var formProps = (0, _extends2["default"])({}, formMixinProps, {
  // 表单选项label的span
  labelSpan: _vueTypes["default"].number.def(6),
  // 表单选项span全部
  totalSpan: _vueTypes["default"].number.def(24),
  // 只可编辑文件上传
  isOnlyEditUpload: _vueTypes["default"].bool.def(false),
  // 不可编辑的key列表
  disabledKeyList: _vueTypes["default"].array.def([]),
  // oss策略信息，针对有图片上传的表单
  ossClient: _vueTypes["default"].object
});
exports.formProps = formProps;